#
# Copyright (c) 2000, 2099, ducesoft and/or its affiliates. All rights reserved.
# DUCESOFT PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
#
#

import mesh.boost as boost
import mesh.cause as cause
import mesh.codec as codec
import mesh.context as context
import mesh.environ as environ
import mesh.grpx as grpx
import mesh.http as http
import mesh.ioc as ioc
import mesh.kinds as kinds
import mesh.log as log
import mesh.macro as macro
import mesh.metrics as metrics
import mesh.mpc as mpc
import mesh.prsim as prsim
import mesh.runtime as runtime
import mesh.schema as schema
import mesh.system as system
import mesh.tool as tool


def init():
    cause.init()
    codec.init()
    grpx.init()
    http.init()
    ioc.init()
    kinds.init()
    log.init()
    macro.init()
    metrics.init()
    mpc.init()
    prsim.init()
    runtime.init()
    schema.init()
    system.init()
    tool.init()
    boost.init()
    context.init()
    environ.init()
